﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.742.5/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var CompoundUserControl;
        (function (CompoundUserControl) {
            function SettingsPopup(ParentControl, UserControl, WhereToInsert, GateName, MotorName, SensorName, Interval) {

                console.log(`GateName = ${GateName}`);
                console.log(`MotorName = ${MotorName}`);
                console.log(`SensorName = ${SensorName}`);
                console.log(`Interval = ${Interval}`);
                var MotorNameIndex = parseInt(MotorName);
                var SensorNameIndex = parseInt(SensorName);
                var popupParametersControl = [];
                var PopupUuid = String("Popup_" + TcHmiEx.Utilities.generateUuidv4());
                var popup;
                var popupType = UserControl.split(".");
                popupType = popupType[popupType.length - 1].toLowerCase();
                popupParametersControl['data-tchmi-left'] = TcHmiEx.Utilities.ClickCoordinates.x;
                popupParametersControl['data-tchmi-top'] = TcHmiEx.Utilities.ClickCoordinates.y;
                popupParametersControl['data-tchmi-height'] = 600;
                popupParametersControl['data-tchmi-width'] = 550;
                popupParametersControl['data-tchmi-zindex'] = "1000";

                var myControl = TcHmi.Controls.get(ParentControl);  //Where we are using the control
                if (myControl) {
                    popupParametersControl['data-tchmi-headernamepopup'] = GateName.concat('.').concat(MotorName).concat('.').concat(SensorName);
                    if (MotorNameIndex == 0) {
                        if (SensorNameIndex == 0) {
                            var symbolRealParameter = TcHmi.Binding.resolveEx('LeftMotorLeftSensorInterval', myControl);
                            if (symbolRealParameter) {
                                popupParametersControl['data-tchmi-intervalpopup'] = symbolRealParameter.toString();
                            }
                        } else {

                            var symbolRealParameter = TcHmi.Binding.resolveEx('LeftMotorRightSensorInterval', myControl);
                            if (symbolRealParameter) {
                                popupParametersControl['data-tchmi-intervalpopup'] = symbolRealParameter.toString();
                            }
                        }
                    } else {

                        if (SensorNameIndex == 0) {
                            var symbolRealParameter = TcHmi.Binding.resolveEx('RightMotorLeftSensorInterval', myControl);
                            if (symbolRealParameter) {
                                popupParametersControl['data-tchmi-intervalpopup'] = symbolRealParameter.toString();
                            }
                        } else {

                            var symbolRealParameter = TcHmi.Binding.resolveEx('RightMotorRightSensorInterval', myControl);
                            if (symbolRealParameter) {
                                popupParametersControl['data-tchmi-intervalpopup'] = symbolRealParameter.toString();
                            }
                        }
                    }              
                }

                if (WhereToInsert == undefined) { WhereToInsert = "Desktop" }
                if (popupType == "usercontrol") {
                    popupParametersControl['data-tchmi-target-user-control'] = UserControl;
                    popup = TcHmi.ControlFactory.createEx(
                        'tchmi-user-control-host',
                        PopupUuid,
                        popupParametersControl
                    );
                }

                var desktop = TcHmi.Controls.get(WhereToInsert.__id);
                if (desktop && popup) {
                    desktop.addChild(popup);
                    TcHmiEx.Utilities.dragElement(document.getElementById(PopupUuid));
                }
            }
            CompoundUserControl.SettingsPopup = SettingsPopup;
        })(CompoundUserControl = Functions.CompoundUserControl || (Functions.CompoundUserControl = {}));
        Functions.registerFunctionEx('SettingsPopup', 'TcHmi.Functions.CompoundUserControl', CompoundUserControl.SettingsPopup);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);