﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.742.5/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var CompoundUserControl;
        (function (CompoundUserControl) {
            function SubscribeSensor(ControlPath, SymbolPath) {
                console.log(`SubscribeSensor ControlPath = ${ControlPath}`);
                console.log(`SubscribeSensor SymbolPath = ${SymbolPath}`);

                var readData = 0.0;
                var motorSpeedControl = TcHmi.Controls.get(ControlPath.concat('.MotorSpeed'));
                if (motorSpeedControl != undefined) {
                    console.log('motorSpeedControl has value');
                    motorSpeedControl.setText(readData.toFixed(2));
                } else {
                    console.log('motorSpeedControl has no value');
                    return;
                }

                if (TcHmi.Server.isWebsocketReady()) {
                var commands = [
                    {
                        'symbol': SymbolPath.concat('.').concat('readData')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('alarm')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('start')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('reset')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('initDone')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('delta')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('interval')
                    },
                    {
                        'symbol': SymbolPath.concat('.').concat('name')
                    }
                ];

                    TcHmi.Server.subscribe(commands, 500, function (data) {


                        if (data.error !== TcHmi.Errors.NONE) {
                            console.log('Step 1');
                            return;
                        }
                        var response = data.response;
                        if (!response || response.error !== undefined) {
                            console.log('Step 2');
                            return;
                        }
                        var commands = response.commands;
                        if (commands === undefined) {
                            console.log('Step 3');
                            return;
                        }

                        for (var i = 0, ii = commands.length; i < ii; i++) {
                            var command = commands[i];
                            if (command === undefined) {
                                console.log('Step 4');
                                return;
                            }
                            if (command.error !== undefined) {
                                console.log(`SubscribeSensor symbol = ${commands[i].symbol} ControlPath = ${ControlPath}`);
                                console.log('Step 5');
                                return;
                            }

                            if (commands[i].symbol.indexOf('readData') > 0) {
                                readData = command.readValue;
                                let aa = parseFloat(readData).toFixed(2);
                                motorSpeedControl.setText(aa);                                
                            }



                        } // for loop


                }); //subscribe
                } //isWebsocketReady



            }
            CompoundUserControl.SubscribeSensor = SubscribeSensor;
        })(CompoundUserControl = Functions.CompoundUserControl || (Functions.CompoundUserControl = {}));
        Functions.registerFunctionEx('SubscribeSensor', 'TcHmi.Functions.CompoundUserControl', CompoundUserControl.SubscribeSensor);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);